-------------------------------------------------
--  This file has been generated automatically
--  by IDLAC version GPL 2007-20070405.
--
--  Do NOT hand-modify this file, as your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
-------------------------------------------------
pragma Style_Checks ("NM32766");

with PolyORB.Utils.Strings;
with PolyORB.Initialization;
pragma Elaborate_All (PolyORB.Initialization);
with PolyORB.QoS.Exception_Informations;
with PolyORB.Any;
with PolyORB.CORBA_P.Domain_Management;
with PolyORB.CORBA_P.IR_Hooks;
with CORBA.Object.Helper;
with CORBA.ORB;
with CORBA.NVList;
with PolyORB.Std;
with CORBA.ServerRequest;
with Suma.Impl;
with CORBA;
pragma Elaborate_All (CORBA);
with PortableServer;
pragma Elaborate_All (PortableServer);
with PolyORB.CORBA_P.Exceptions;

package body Suma.Skel is

   --  Skeleton subprograms

   function Servant_Is_A (Obj : PortableServer.Servant) return Boolean;

   function Servant_Is_A (Obj : PortableServer.Servant) return Boolean is
   begin
      return Obj.all in Suma.Impl.Object'Class;
   end Servant_Is_A;

   Is_A_Arg_Name__Type_Id : constant CORBA.Identifier :=
      CORBA.To_CORBA_String ("Type_Id");

   SumaNum_Arg_Name__x : constant CORBA.Identifier :=
      CORBA.To_CORBA_String ("x");
   SumaNum_Arg_Name__y : constant CORBA.Identifier :=
      CORBA.To_CORBA_String ("y");

   procedure Invoke
     (Self    : PortableServer.Servant;
      Request : CORBA.ServerRequest.Object_Ptr)
   is
      Operation  : constant PolyORB.Std.String :=
         CORBA.To_Standard_String
           (CORBA.ServerRequest.Operation (Request.all));
      Arg_List_ : CORBA.NVList.Ref;
   begin
      CORBA.ORB.Create_List (0, Arg_List_);
      if Operation = "_is_a" then
         declare
            Type_Id           : CORBA.String;
            Arg_Any__Type_Id : CORBA.Any := CORBA.To_Any (Type_Id);

            Result_ : CORBA.Boolean;
         begin
            CORBA.NVList.Add_Item
              (Arg_List_,
               Is_A_Arg_Name__Type_Id,
               Arg_Any__Type_Id,
               CORBA.ARG_IN);

            CORBA.ServerRequest.Arguments (Request, Arg_List_);

            begin
            --  Convert arguments from their Any

               Type_Id := CORBA.From_Any (Arg_Any__Type_Id);

               --  Call implementation

               Result_ := Suma.Is_A (CORBA.To_Standard_String (Type_Id));
            end;

            -- Set Result

            CORBA.ServerRequest.Set_Result (Request, CORBA.To_Any (Result_));
         end;

      elsif Operation = "_non_existent"
        or else Operation = "_not_existent"
      then

         CORBA.ServerRequest.Arguments (Request, Arg_List_);

         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.To_Any (CORBA.Boolean'(False)));

      elsif Operation = "_interface" then

         CORBA.ServerRequest.Arguments (Request, Arg_List_);

         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.Object.Helper.To_Any
               (CORBA.Object.Ref (
            PolyORB.CORBA_P.IR_Hooks.Get_Interface_Definition
  (CORBA.To_CORBA_String (Repository_Id)))));

      elsif Operation = "_domain_managers" then

         CORBA.ServerRequest.Arguments (Request, Arg_List_);

         CORBA.ServerRequest.Set_Result
           (Request,
            PolyORB.CORBA_P.Domain_Management.Get_Domain_Managers (Self));

      elsif Operation = "SumaNum" then

         declare
            Argument__x : CORBA.Long;
            pragma Warnings (Off, Argument__x);
            Arg_CC__x  : aliased PolyORB.Any.Content'Class :=
               CORBA.Wrap (Argument__x'Unrestricted_Access);
            Arg_Any__x : CORBA.Any                         :=
               CORBA.Internals.Get_Wrapper_Any
                 (CORBA.TC_Long,
                  Arg_CC__x'Unchecked_Access);

            Argument__y : CORBA.Long;
            pragma Warnings (Off, Argument__y);
            Arg_CC__y  : aliased PolyORB.Any.Content'Class :=
               CORBA.Wrap (Argument__y'Unrestricted_Access);
            Arg_Any__y : CORBA.Any                         :=
               CORBA.Internals.Get_Wrapper_Any
                 (CORBA.TC_Long,
                  Arg_CC__y'Unchecked_Access);

            Result_ : CORBA.Long;
            pragma Warnings (Off, Result_);
            Arg_CC__Result_  : aliased PolyORB.Any.Content'Class :=
               CORBA.Wrap (Result_'Unrestricted_Access);
            Arg_Any__Result_ : CORBA.Any                         :=
               CORBA.Internals.Get_Wrapper_Any
                 (CORBA.TC_Long,
                  Arg_CC__Result_'Unchecked_Access);
         begin
            CORBA.NVList.Add_Item
              (Arg_List_,
               SumaNum_Arg_Name__x,
               Arg_Any__x,
               CORBA.ARG_IN);
            CORBA.NVList.Add_Item
              (Arg_List_,
               SumaNum_Arg_Name__y,
               Arg_Any__y,
               CORBA.ARG_IN);

            CORBA.ServerRequest.Arguments (Request, Arg_List_);

            begin
               Result_ :=
                  Suma.Impl.SumaNum
                    (Suma.Impl.Object'Class (Self.all)'Access,
                     Argument__x,
                     Argument__y);
            end;
            CORBA.ServerRequest.Set_Result (Request, Arg_Any__Result_);
            CORBA.NVList.Internals.Clone_Out_Args (Arg_List_);
            return;
         end;

      else
         CORBA.Raise_Bad_Operation (CORBA.Default_Sys_Member);
      end if;
   exception
      when E : others =>
         CORBA.ServerRequest.Set_Exception
           (Request,
            CORBA.Internals.To_CORBA_Any
               (PolyORB.CORBA_P.Exceptions.System_Exception_To_Any (E)));
         PolyORB.QoS.Exception_Informations.Set_Exception_Information
           (Request,
            E);
   end Invoke;

   procedure Deferred_Initialization is
   begin
      PortableServer.Internals.Register_Skeleton
        (CORBA.To_CORBA_String (Suma.Repository_Id),
         Servant_Is_A'Access,
         Is_A'Access,
         Invoke'Access);

   end Deferred_Initialization;

begin
   declare
      use PolyORB.Initialization;
      use PolyORB.Initialization.String_Lists;
      use PolyORB.Utils.Strings;
   begin
      Register_Module
        (Module_Info'
        (Name      => +"Suma.Skel",
         Conflicts => PolyORB.Initialization.String_Lists.Empty,
         Depends   => PolyORB.Initialization.String_Lists.Empty,
         Provides  => PolyORB.Initialization.String_Lists.Empty,
         Implicit  => False,
         Init      => Deferred_Initialization'Access,
         Shutdown  => null));
   end;

end Suma.Skel;
